config/routes.rb
Rails.application.routes.draw do
  resources :challenges do
    resources :votes, only: [:create, :destroy], shallow: true
    resources :collaborations, only: [:create, :destroy], shallow: true
  end
  devise_for :emps
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root "challenges#index"
  get "pages/", to: "pages#index"
end

app/models/challenge.rb
class Challenge < ApplicationRecord
  belongs_to :emp
  has_many :tags, dependent: :destroy
  has_many :votes, dependent: :destroy
  has_many :collaborations, dependent: :destroy

  validates :title, presence: true
  validates :description, presence: true

  def is_liked(emp)
    Vote.find_by(emp_id: emp.id, challenge_id: id)
  end

  def is_collaborated(emp)
    Collaboration.find_by(emp_id: emp.id, challenge_id: id)
  end

  def self.idsearch(search)
    if search
      @challenges = Challenge.where("emp_id like '%#{search}%'")
      #if challenge_of
      #  self.where(challenge_id: challenge_of)
      #else
      #  @challenges = Challenge.all
      #end
    else
      @challenges = Challenge.all
    end
  end
  def self.title_search(search)
    if search
      @challenges = Challenge.where("title like '%#{search}'")
    else
      @challenges = Challenge.all
    end
  end
end

app/controllers/challenges_controller.rb
class ChallengesController < ApplicationController
  include ChallengesHelper
  before_action :set_challenge, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_emp!, only: [:edit, :update, :destroy]
  # GET /challenges
  # GET /challenges.json
  def index
    @challenges = ChallengesIndex.new(params).display_challenges
  end

  # GET /challenges/1
  # GET /challenges/1.json
  def show
  end

  # GET /challenges/new
  def new
    @challenge = Challenge.new
  end

  # GET /challenges/1/edit

  # POST /challenges
  # POST /challenges.json
  def create
    #@challenge = Challenge.new(challenge_params)
    #@challenge = current_emp.challenges.build(title: params[:challenge][:title], description: params[:challenge][:description])
    #@challenge = ChallengeCreator.new(challenge_params).creation(current_emp)
    @challenge = ChallengeFactory.new.challenge_creator(challenge_params, current_emp)
    if @challenge
      respond_to do |format|
        format.html { redirect_to root_path, notice: "Challenge was successfully created." }
        format.json { render :show, status: :created, location: @challenge }
      end
    else
      respond_to do |format|
        format.html { render :new }
        format.json { render json: @challenge.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /challenges/1
  # DELETE /challenges/1.json
  def destroy
    @challenge.destroy
    respond_to do |format|
      format.html { redirect_to challenges_url, notice: "Challenge was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_challenge
    @challenge = Challenge.find(params[:id])
    #  @challenges = Challenge.search(params[:search])
  end

  # Only allow a list of trusted parameters through.
  def challenge_params
    params.require(:challenge).permit(:title, :description, :emp_id, :tag, :idsearch, :title_search, :current_emp, :sort_by)
  end
end

#index
#@challenges = Challenge.all

#elsif params[:current_emp] != nil
# @challenges = Challenge.get_challenges(params[:current_emp])

#@challenges = Challenge.all.order(created_at: :desc)
#@challenges = Challenge.includes(:votes).group("challenge_id").order(count: :desc).count
#@challenges = Challenge.joins(:votes).group("challenge_id").order(challenge_id: :desc)
=begin
  def edit
  end

  def update
    respond_to do |format|
      if @challenge.update(challenge_params)
        format.html { redirect_to @challenge, notice: "Challenge was successfully updated." }
        format.json { render :show, status: :ok, location: @challenge }
      else
        format.html { render :edit }
        format.json { render json: @challenge.errors, status: :unprocessable_entity }
      end
    end
  end
=end

app/helpers/challenges_helper.rb
module ChallengesHelper
  class ChallengeFactory < BaseFactory
    def adder(challenge_params, current_emp)
      ChallengeCreator.new(challenge_params).creation(current_emp)
    end
  end
end

app/views/challenges/_form.html.erb
<%= form_with(model: challenge) do |form| %>
  

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description %>
  </div>

  <div class="field">
    <%= form.label :emp_id %>
    <%= form.text_field :emp_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/challenges/edit.html.erb
<h1>Editing Challenge</h1>

<%= render 'form', challenge: @challenge %>

<%= link_to 'Show', @challenge %> |
<%= link_to 'Back', challenges_path %>

app/views/challenges/new.html.erb
<h1>New Challenge</h1>

<%= render 'form', challenge: @challenge %>

<%= link_to 'Back', challenges_path %>

app/views/challenges/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @challenge.title %>
</p>

<p>
  <strong>Description:</strong>
  <%= @challenge.description %>
</p>

<p>
  <strong>Emp:</strong>
  <%= @challenge.emp_id %>
</p>
<p> 
  <strong>Collab requests:</strong>
  <% @challenge.collaborations.each do |collab_request| %>
  <%=collab_request.emp_id%>
  <%end%>
</p>

<%= link_to 'Edit', edit_challenge_path(@challenge) %> |
<%= link_to 'Back', challenges_path %>